package com.ar.drawing.assistant.paint.ui_activity;

import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.ImageView;

import androidx.annotation.NonNull;
import androidx.appcompat.app.AppCompatActivity;
import androidx.core.content.ContextCompat;
import androidx.fragment.app.Fragment;
import androidx.viewpager2.adapter.FragmentStateAdapter;
import androidx.viewpager2.widget.ViewPager2;

import com.ar.drawing.assistant.paint.R;
import com.ar.drawing.assistant.paint.ad.AdManager;
import com.ar.drawing.assistant.paint.databinding.ActHomeBinding;
import com.ar.drawing.assistant.paint.ui_fragment.FragFavorite;
import com.ar.drawing.assistant.paint.ui_fragment.FragHome;
import com.ar.drawing.assistant.paint.ui_fragment.FragImport;
import com.ar.drawing.assistant.paint.utils.Common;
import com.google.android.material.tabs.TabLayout;

import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

public class ActMain extends AppCompatActivity {

    private ActHomeBinding binding;

    private List<Fragment> listFragment = new ArrayList<>();




    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        Common.setStatusBarTextColor(this, true);
        binding = ActHomeBinding.inflate(getLayoutInflater());
        setContentView(binding.getRoot());
        listFragment.add(FragHome.newInstance());
        listFragment.add(FragImport.newInstance());
        listFragment.add(FragFavorite.newInstance());
        AdManager.loadAllAd();
        onTabInit();
        binding.viewPager2.setUserInputEnabled(false);
        binding.viewPager2.setAdapter(new FragmentStateAdapter(this) {
            @NonNull
            @Override
            public Fragment createFragment(int position) {
                return listFragment.get(position);
            }

            @Override
            public int getItemCount() {
                return listFragment.size();
            }
        });
        bingTabVp();
    }
    private void bingTabVp() {
        binding.tab.addOnTabSelectedListener(new TabLayout.OnTabSelectedListener() {
            @Override
            public void onTabSelected(TabLayout.Tab tab) {
                ImageView icon = Objects.requireNonNull(tab.getCustomView()).findViewById(R.id.im_icon);
                icon.setSelected(true);
                binding.viewPager2.setCurrentItem(tab.getPosition());
            }

            @Override
            public void onTabUnselected(TabLayout.Tab tab) {
                ImageView icon = Objects.requireNonNull(tab.getCustomView()).findViewById(R.id.im_icon);
                icon.setSelected(false);
            }

            @Override
            public void onTabReselected(TabLayout.Tab tab) {

            }
        });
        binding.viewPager2.registerOnPageChangeCallback(new ViewPager2.OnPageChangeCallback() {
            @Override
            public void onPageSelected(int position) {
                super.onPageSelected(position);
                Objects.requireNonNull(binding.tab.getTabAt(position)).select();
            }
        });
    }


    private void onTabInit() {

        for (int i = 0; i < listFragment.size(); i++) {
            TabLayout.Tab tab = binding.tab.newTab();
            View inflate = LayoutInflater.from(this).inflate(R.layout.it_tab, null, false);
            ImageView icon = inflate.findViewById(R.id.im_icon);
            if (i == 0) {
                icon.setImageDrawable(ContextCompat.getDrawable(this, R.drawable.choose_tab_home));
            } else  if (i == 1){
                icon.setImageDrawable(ContextCompat.getDrawable(this, R.drawable.choose_import));
            }else {
                icon.setImageDrawable(ContextCompat.getDrawable(this, R.drawable.choose_tab_like));
            }
            tab.setCustomView(inflate);
            binding.tab.addTab(tab);
        }

    }


}